<template>
<nav aria-label="breadcrumb" class="ecl-breadcrumb">
  <ol class="ecl-breadcrumb__container">
    <slot>
      <BreadcrumbsItem
        v-for="(item, i) in computedItems"
        :key="`breadcrumb-item@${i}`"
        :to="to(item)"
        :href="item.href"
        :text="item.text"
        :active="item.active || i === computedItems.length - 1"
        :disable-separator="i === computedItems.length - 1"
      />
    </slot>
  </ol>
</nav>
</template>

<script>
import { defineComponent } from 'vue';

// ts-ignore
import useRouteMetaBreadcrumbs from './useRouteMetaBreadcrumbs';
import BreadcrumbsItem from './BreadcrumbsItem.vue';

export default defineComponent({
  name: 'Breadcrumbs',
  props: {
    items: {
      type: Array,
    },
    useRouteMeta: {
      type: Boolean,
      default: false,
    },
    useSelectedLocale: {
      type: Boolean,
      default: true,
    },
  },
  mixins: [useRouteMetaBreadcrumbs],
  components: {
    BreadcrumbsItem,
  },
  computed: {
    computedItems() {
      if (this.useRouteMeta) {
        return this.$breadcrumbs;
      }
      return this.items;
    },
  },
  methods: {
    to(item) {
      if (item.to) {
        if (this.useSelectedLocale && typeof item.to === 'object') {
          let query = { locale: this.$i18n.locale };
          if (item.to.query) {
            query = { ...item.to.query, ...query };
          }
          return { ...item.to, query };
        }
        return item.to;
      }
      return null;
    },
  },
});
</script>

<style>

</style>
